unit Main;

//Nevim proc, ale funguje to urcite na trech mestech a to na jakkoli na Acs, Aalen a Abovce...
//Jeste sem pak zjistil, ze to vetsinou nefunguje podruhe. Program se musi vypnout a zapnout.
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, xmldom, XMLIntf, Sockets, StdCtrls, msxmldom, XMLDoc, Spin,
  ComCtrls;

type
  TForm1 = class(TForm)
    XMLDocument: TXMLDocument;
    EPort: TEdit;
    EHost: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BCon: TButton;
    BDisCon: TButton;
    TcpClient: TTcpClient;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    BSearch: TButton;
    CBOd: TComboBox;
    CBKam: TComboBox;
    CBPres: TComboBox;
    SEMax: TSpinEdit;
    SEVrat: TSpinEdit;
    TVSpoje: TTreeView;
    label9: TLabel;
    EOdjezd: TEdit;
    procedure BConClick(Sender: TObject);
    procedure BDisConClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetSeznamStanic;
    procedure BSearchClick(Sender: TObject);
    procedure GetNajdiSpojeni;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Temp: TStringList;

implementation

{$R *.dfm}

procedure TForm1.BConClick(Sender: TObject);
begin
  if (EPort.Text <> '') and (EHost.Text <> '') then
  begin
    TcpClient.RemotePort:=EPort.Text;
    TcpClient.RemoteHost:=EHost.Text;
    if not TcpClient.Connect then
    begin
      ShowMessage('Unable to connect');
      exit;
    end;
    BDisCon.Enabled:=true;
    BSearch.Enabled:=true;
    BCon.Enabled:=False;
  end;
  GetSeznamStanic;
end;

procedure TForm1.BDisConClick(Sender: TObject);
begin
  TcpClient.Disconnect;
  BCon.Enabled:=true;
  BSearch.Enabled:=False;
  BDisCon.Enabled:=False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Temp:=TStringList.Create;
end;

procedure TForm1.GetSeznamStanic;//procedura, ktera ziska seznam vsech stanic od serveru
var
  i: integer;//pocitadlo pro for cyklus
  radek: String;//Zapamatuje si adek, ktery prave od serveru dostal
  stanice: IXMLNodeList;//Pamatuje si urcite misto v XML souboru a jeho sub nody
begin
  Temp.Clear;
  CBOd.Clear;
  CBKam.Clear;
  CBPres.Clear;

  CBOd.Items.Add('---OD---');
  CBKam.Items.Add('---KAM---');
  CBPres.Items.Add('---PRES---');

  CBOd.ItemIndex:=0;
  CBKam.ItemIndex:=0;
  CBPres.ItemIndex:=0;

  //Nejdriv vse vycistim

  TcpClient.Sendln('GET /SeznamStanic HTTP/1.0');//...pak zaslu pozadavek serveru
  TcpClient.Sendln('host: '+EHost.Text);
  TcpClient.Sendln('');
  radek:=TcpClient.Receiveln();//...prijmu odpoved serveru
  if not Pos('200',radek) = 0 then//Zjistim, jestli neni odpoved chybna(jestli obsahuje cislo 200)
  begin
    ShowMessage('Nebylo mozne nacist seznam stanic.');
    exit;
  end;
  radek:=TcpClient.Receiveln;//Ctu radky do te doby, ney narayim na prazdny
  while radek <> '' do
  begin
    radek:=TcpClient.Receiveln;
  end;

  radek:=TcpClient.Receiveln;//Ted si zbytek dat ulozim do souboru Temp.xml a nactu ho do komponenty XMLDocument
  Temp.Add(radek);
  while radek <> '' do
  begin
    radek:=TcpClient.Receiveln;
    Temp.Add(radek);
  end;
  Temp.SaveToFile('Temp.xml');
  XMLDocument.LoadFromFile('Temp.xml');

  stanice:=XMLDocument.ChildNodes.Nodes[0].ChildNodes;//Tady si ukladam jednotlive stanice do vsech tri ComboBoxu
  for i:=0 to stanice.Count -1 do
  begin
    CBOd.Items.Add(stanice.Nodes[i].NodeValue);
    CBKam.Items.Add(stanice.Nodes[i].NodeValue);
    CBPres.Items.Add(stanice.Nodes[i].NodeValue);
  end;
  TcpClient.Disconnect;
  TcpClient.Connect;
end;
procedure TForm1.BSearchClick(Sender: TObject);
begin
  if (CBOd.Text = '---OD---') or (CBKam.Text = '---KAM---') then
  begin
    ShowMessage('Musite zadat, odkud kam chcete jet.');
    exit;
  end;

  if (SEVrat.Value = 0) then
  begin
    ShowMessage('Pocet vracenych spoju nesmi byt nulovy');
    exit;
  end;

  if not length(EOdjezd.Text)=4 then
  begin
    ShowMessage('Cas odjezdu zadavejte ve formatu hhmm');
  end;

  GetNajdiSpojeni;
end;

procedure TForm1.GetNajdiSpojeni;
var
  i,j,k,l: integer;
  radek: String;
  od, kam, pres: String;
  spojeni,
  spoj,
  linka,
  stanice: IXMLNode;
  tvspojeni,
  tvspoj,
  tvlinka,
  tvstanice: TTreeNode;
  cislo, caso, casp, ted,prij,odj, konecna,odjezd: String;
begin
  temp.Clear;
  if Pos(' ',CBOd.Text) <> 0 then
  begin
    for i:=1 to Length(CBOd.Text)-1 do
    begin
      if CBOd.Text[i] <> ' ' then od:=od+CBOd.Text[i]
      else od:=od+'+';
    end;
  end
  else od:= CBOd.Text;

  if Pos(' ',CBKam.Text) <> 0 then
  begin
    for i:=1 to Length(CBKam.Text)-1 do
    begin
      if CBKam.Text[i] <> ' ' then kam:=kam+CBKam.Text[i]
      else kam:=kam+'+';
    end;
  end
  else kam:= CBkam.Text;

  if Pos(' ',CBPres.Text) <> 0 then
  begin
    for i:=1 to Length(CBpres.Text)-1 do
    begin
      if CBpres.Text[i] <> ' ' then pres:=pres+CBPres.Text[i]
      else pres:=pres+'+';
    end;
  end
  else pres:= CBPres.Text;
  TcpClient.Sendln('GET /NajdiSpojeni?odkud='+od+'&kam='+kam+'&pres='+pres+'&odjezd='+EOdjezd.text+'&prestupy='+IntToStr(SEMax.Value)+'&spojeni='+IntToStr(SEVrat.Value)+' HTTP/1.0');
  TcpClient.Sendln('');
  radek:=TcpClient.Receiveln;
  if pos('200', radek) = 0 then
  begin
    ShowMessage('Pri zpracovani pozadavku doslo k chybe');
    exit;
  end;
  while radek <> '' do
  begin
    radek:=TcpClient.Receiveln;
  end;
  radek:=TcpClient.Receiveln;
  Temp.Add(radek);
  while radek <> '' do
  begin
    radek:=TcpClient.Receiveln;
    Temp.Add(radek);
  end;

  Temp.SaveToFile('temp.xml');
  XMLDocument.LoadFromFile('Temp.xml');

  tvspojeni:=TVSpoje.Items.AddFirst(nil,CBOd.Text+' - '+CBKam.Text);
  spojeni:=XMLDocument.ChildNodes.Nodes[0];
  if spojeni.NodeName <> 'chyba' then
  begin
    for i:=0 to spojeni.ChildNodes.Count-1 do
    begin
      spoj:=spojeni.ChildNodes.Nodes[i];
      caso:=spoj.ChildNodes.Nodes[0].ChildNodes.Nodes[0].Attributes['odjezd'];
      tvspoj:=TVSpoje.Items.AddChild(tvspojeni,'Odjezd: '+caso);
      for j:=0 to spoj.ChildNodes.Count-1 do
      begin
        linka:=spoj.ChildNodes.Nodes[j];
        cislo:=linka.Attributes['cislo'];
        tvlinka:=TVSpoje.Items.AddChild(tvspoj,'vlak '+cislo+' '+linka.ChildNodes.Nodes[0].NodeValue);
        for k:=0 to linka.ChildNodes.Count-1 do
        begin
          stanice:=linka.ChildNodes.Nodes[k];
          if stanice.NodeName = 'Stanice' then
          begin
            ted:=stanice.NodeValue;
            if stanice.HasAttribute('prijezd') then prij:=stanice.Attributes['prijezd']
            else prij:='';
            if stanice.HasAttribute('odjezd') then odj:=stanice.Attributes['odjezd']
            else odj:='';

            tvstanice:=TVSpoje.Items.AddChild(tvlinka,prij+' - '+odj+' : '+ted);
            konecna:=ted;
          end
          else
          begin
            ted:=stanice.NodeValue;
            tvstanice:=TVSpoje.Items.AddChild(tvlinka,'pozn: '+ted)
          end;
        end;
        tvlinka.Text:=tvlinka.Text+' - '+konecna;
      end;
    end;
  end
  else showmessage('chyba');

end;
end.

